#define VER      "6.03"
#define FORMATVER "1.0"
#define NAZVA    "LuckyGate" HALF " " VER
#define COPYRIGHT NAZVA "   " __DATE__
#define MAXHOSTS 64
#define MAXSEND  64

#if defined (MAXPATH)
#define FNAME_MAX   (MAXPATH+1)
#elif defined (PATH_MAX)
#define FNAME_MAX   (PATH_MAX+1)
#else
#ifdef __MSDOS__
#define FNAME_MAX   81
#else
#define FNAME_MAX   257
#endif
#endif

#define BUFSIZE   8192
#define UUEREQ    400000l
#define UUDEREQ   400000l
#define RMAILREQ  400000l
#define UUCPREQ   400000l
#define MAXPASSWD 33

#define TMPUUE   "temp????.uue"
#define TMPSENT  "att?????.snt"
#define SENTBAD  "fail????.snt"
#define BSYNAME  "attuucp.now"

#define RET_SENT	1
#define RET_RCV		2
#define RET_FWD		4
#define RET_WARN	8
#define RET_ERR		16

#define KENDRA		112
#define SENDMAIL	86

#if defined(__MSDOS__)
#define SYSTEM "MSDOS"
#define _Far far
#define HALF "/DOS"
#define MAINTYPE int cdecl
#define EXEEXT ".exe"
#ifdef O_EXCL
extern int share;
#undef O_EXCL
#define O_EXCL (share ? 0x0400 : 0)
#endif
#elif defined(__OS2__)
#define SYSTEM "OS/2"
#define HALF "/2"
#define _Far
#define MAINTYPE int
#define EXEEXT ".exe"
#else
#define SYSTEM "UNIX"
#define HALF "/Unix"
#define _Far
#define MAINTYPE int
#define EXEEXT ""
#define myfopen(file,mode)	fopen(file,mode)
#define setmode(file,mode)
#endif
#ifdef HAVE_FTRUNCATE
#define chsize(file,size)	ftruncate(file,size)
#endif

#include <fidolib.h>

#define tmpdir _tmpdir

#ifdef __EMX__
#define cwait(status, pid, option)	waitpid(pid, status, 0)
#define mkdir(path)			mkdir(path, 0750)
#ifdef __OS2__
#define getcwd(buf, size)		_getcwd2(buf, size)
#endif
#endif

#define addslash(str)  if ((str)[0] && (str)[strlen(str)-1]!=PATHSEP) strcat(str, PATHSTR)

#if !defined (LOCK_SH)
#define LOCK_SH     0x01
#define LOCK_EX     0x02
#define LOCK_NB     0x04
#define LOCK_UN     0x08
#endif
#if defined(__TURBOC__)
#define flock(h, mode)	(share ? (((mode) & LOCK_UN) ? unlock(h, 0, 0x7fffffffl) : lock(h, 0, 0x7fffffffl)) : 0)
int _Cdecl lock    (int handle, long offset, long length);
int _Cdecl unlock  (int handle, long offset, long length);
#elif defined(__WATCOMC__)
#define flock(h, mode)	(((mode) & LOCK_UN) ? unlock(h, 0, 0x7fffffffl) : lock(h, 0, 0x7fffffffl))
int  lock(int __handle,unsigned long __offset,unsigned long __nbytes);
int  unlock(int __handle,unsigned long __offset,unsigned long __nbytes);
#endif

int  config(void);
int  uucp(char * filename,char * host);
void uudecode(char * filename);
void flushsend(void);
int  params(int argc, char * argv[]);
void setglobal(char * var,char * value);
int  init_tpl(char * fname);
void close_tpl(void);
void closeall(void);
void setpath(char * fname);
int  configline(char * str,unsigned size);
char *getvar(char * var);
int  mktempname(char * sample,char * dest);
void checktmp(void);
void mkarcname(char * src,char * arcname,int passwd);
void topostmast(char * tmp_uue);
int  checkpgpsig(char *fname, char *pgpsig, char *from);
char *getsign(char *fname);
void chsubstr(char * str,char * from,char * to);
int  swap_system(char * cmd);
int  pipe_system0(int * in,int * out,char * cmd,char * argv0);
#define pipe_system(in,out,cmd) pipe_system0(in,out,cmd,NULL);
int  pipe_spawnv(int * in,int * out,char * name, char * args[]);
void expand_path(char * src,char * dest);
void movebad(char * fname,long attrib);
void makename(char * src,char * destname,char * destdir);
int  isfile(int handle);
void getvalue(char * field,char * value,unsigned valsize);
void getparam(char * field,char * param,char * value,unsigned valsize);
int  getmytz(char * str, int * tz);
void cdecl debug(int level,char * format,...);
int  saveargs(int argc, char * argv[]);
unsigned long filecrc32(char * fname);
int  do_uudecode(char * infile,char * outfile);
int  do_unbase64(char * infile,char * outfile);
int  str_unbase64(char *in, char *out);
void str_base64(char *in, char *out, int len);
#if defined (__STDIO_DEF_) || defined (_STDIO_H_INCLUDED) || defined (__STDIO_H) || defined (_STDIO_H) || defined(_STDIO_H_)
int  do_uuencode(char * infile,FILE * fout);
int  do_base64(char * infile, FILE * out);
#ifndef UNIX
FILE * myfopen(char * fname,char * attr);
#endif
#endif
int  cmpaddr(char * addr,char * mask);
typedef enum { ACK_OK, ACK_FAIL } acktype;
void sendack(char *addr, char *msgid, acktype result, char *reason);
void resend(void);
void easet(char *path, const char *name, const char *value);
char *get_ea(char *path, char *name);
#ifndef HAVE_BASENAME
char *basename(char *fname);
#endif
#ifndef HAVE_STRUPR
char *strupr(char *str);
char *strlwr(char *str);
#endif

extern char rmail[FNAME_MAX],netdir[FNAME_MAX];
extern char domain[64];
extern char local[80],remote[80],fidosystem[80];
extern char uupcdir[FNAME_MAX];
extern char * myname;
extern char filebox[FNAME_MAX];
extern char user[80];
extern char rescan[FNAME_MAX];
extern char newechoflag[FNAME_MAX];
extern int  newecho;
extern char postmaster[80];
extern char pktout[FNAME_MAX];
extern char tmpdir[FNAME_MAX];
extern char incomplete[FNAME_MAX], sentdir[FNAME_MAX];
extern char nconf[FNAME_MAX];
extern char binkout[FNAME_MAX];
extern char tboxes[FNAME_MAX];
#ifndef __MSDOS__
extern char lbso[FNAME_MAX], tlboxes[FNAME_MAX], longboxes[FNAME_MAX];
#endif
extern char unsecure[FNAME_MAX];
extern char badmail[FNAME_MAX];
extern char semdir[FNAME_MAX];
extern char sstr[2048],addrlist[1024];
extern char uuencode_fmt[FNAME_MAX],uudecode_fmt[FNAME_MAX];
extern char pgpenc_fmt[FNAME_MAX], pgpdec_fmt[FNAME_MAX];
extern char pgpcheck_fmt[FNAME_MAX], pgpsign_fmt[FNAME_MAX];
extern char *pgpsig;
extern char confirm[80], msgid[256];
extern char boundary[1024];
extern char precedence[80];
extern int f;
extern int nosend,norcv,bypipe,fake,nocrc;
extern unsigned maxuue;
extern char flo_only;
extern int uupcver;
typedef enum { ENC_UUCP, ENC_UUE, ENC_BASE64, ENC_PGP } enctype;
extern struct hostype
  { ftnaddr addr;
#ifndef __MSDOS__
    char domain[32];
#endif
    char host[80];
    enctype enc;
    char dir[FNAME_MAX];
    char passwd[MAXPASSWD];
    char pgpsig;
    unsigned long confirm, confirm_fail; /* in secs */
    unsigned size;
  } * hosts;
typedef enum {NO_SEM, FD_SEM, BINK_SEM, LBSO_SEM} semtype;
extern struct sendtype
  { char filename[FNAME_MAX];
    unsigned host;
    long attr;
    semtype sem;
  } * tosend;
extern unsigned nsend;
extern int nhosts;
extern int tz,quiet;
extern int  use_swap;
extern ftnaddr my;
extern int nglobal,inconfig,tplout;
extern char str[2048];
extern char from[128];
extern int  retcode;
extern int  debuglevel, debuglog;
extern int  curhost;
extern unsigned long fcrc32;
typedef enum {FD_LOG, FE_LOG, SYSLOG_LOG} logtype;
extern logtype logstyle;
typedef struct
       { char *str;
#ifndef __MSDOS__
         void *regbuf;
#endif
       } wildcard;
#ifdef BSD
extern char **environ;
#endif
