#ifdef HAVE_IO_H
#include <io.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "fidolib.h"

int pascal copyfile(char * from,char * to)
{ int fin,fout,r;

  if (access(to,0)==0)
    return 1;
  fin=open(from,O_BINARY|O_RDONLY);
  if (fin==-1) return 1;
  fout=open(to,O_BINARY|O_CREAT|O_RDWR|O_EXCL,S_IREAD|S_IWRITE);
  if (fout==-1)
  { close(fin);
    return 2;
  }
  while ((r=read(fin,buffer,bufsize))==bufsize)
    if (write(fout,buffer,r)!=r)
    { close(fin);
      close(fout);
      unlink(to);
      return 3;
    }
  if (r)
    if (write(fout,buffer,r)!=r)
    { close(fin);
      close(fout);
      unlink(to);
      return 4;
    }
  close(fin);
  close(fout);
  return 0;
}
