#ifdef HAVE_IO_H
#include <io.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <stdio.h>
#include <string.h>
#include "fidolib.h"

int pascal rmove(char * oldname,char * newname)
{
  int  i;
  char * p;

  if (move(oldname,newname)==0)
    return 0;
  else if (access(newname, 0))
    return 1;
  p=strrchr(newname,PATHSEP);
  if (p==NULL) p=newname;
  p=strchr(p,'.');
  if (p==NULL) p=newname+strlen(newname);
  *p++='.';
  if (*p==0)
    p[0]=p[1]='0';
  else if (p[1]==0)
    p[1]=0;
  for (i=1;i<1111;i++)
  {
    p[2]=i%10+'0';
    if (i%10==0)
    { p[1]=(i/10)%10+'0';
      if (i%100==0)
        p[0]=(i%1000)/100+'0';
    }
    if (access(newname,0))
    { if (move(oldname,newname)==0)
        return 0;
      else if (access(newname, 0))
        return 1;
    }
  }
  return 2;
}
