#include <io.h>
#include <fcntl.h>
#include <time.h>
#include "utime.h"

int utime(char * path, struct utimbuf * times)
{
  struct ftime ft;
  struct tm * ftm;
  int h, r;

  ftm=localtime(&times->modtime);
  h=open(path,O_RDWR|O_DENYNONE);
  if (h==-1) return -1;
  ft.ft_tsec=ftm->tm_sec/2;
  ft.ft_min=ftm->tm_min;
  ft.ft_hour=ftm->tm_hour;
  ft.ft_day=ftm->tm_mday;
  ft.ft_month=ftm->tm_mon;
  ft.ft_year=ftm->tm_year-80;
  r=setftime(h,&ft);
  close(h);
  return r;
}
