DEFINES = -DHAVE_DIRECT_H -DHAVE_IO_H -DHAVE_DOS_H -DHAVE_MALLOC_H -DHAVE_SYS_UTIME_H -DHAVE_MKTIME
CC = wcc386
CFLAGS = /bm /w3 /fo=$@ $(DEFINES)
LIB = wlib

OBJS = &
 myopen.obj &
 montable.obj &
 weekday.obj &
 daymon.obj &
 copyfile.obj &
 getfaddr.obj &
 crc.obj &
 binksem.obj &
 lbsosem.obj &
 fdsem.obj &
 bsyname.obj &
 getfmask.obj &
 chkmask.obj &
 touch.obj &
 logwrite.obj &
 dayweek.obj &
 movefile.obj &
 rmove.obj &
 hgets.obj &
 scanbink.obj

all:	flibp.lib

clean:	.SYMBOLIC
	rm -f $(OBJS) flibp.bak

flibp.lib:	$(OBJS)
	$(LIB) $@ +- $?

.c.obj:
	$(CC) $(CFLAGS) $<

$(OBJS):	fidolib.h

scanbink.obj:	scanbnk.c fidolib.h
	$(CC) $(CFLAGS) scanbnk.c
