#ifdef HAVE_IO_H
#include <io.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <stdio.h>
#include "fidolib.h"

int pascal move(char * oldname,char * newname)
{
  if (access(newname,0)==0)
    return 1;
#ifdef HAVE_LINK
  if (link(oldname, newname)==0)
  { unlink(oldname);
    return 0;
  }
#else
  if (rename(oldname,newname)==0)
    return 0;
#endif
  if (copyfile(oldname,newname))
    return 1;
  unlink(oldname);
  return 0;
}
