#ifdef HAVE_IO_H
#include <io.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#define WAITSTATE 5  /* 0.5 sec */
#define MAXTRIES  10 /* 10*0.5=5 sec , ᫥ 祣 ᢠ */

#ifndef O_DENYNONE
#ifdef O_DENYNO
#define O_DENYNONE O_DENYNO
#else
#define O_DENYNONE 0
#endif
#endif

void pascal dvdelay(unsigned decsec);

int myopen(char * filename,unsigned attr)
{
  int i,h;

  for (i=0;;i++)
  { h=open(filename,attr|O_DENYNONE,S_IREAD|S_IWRITE);
    if (h!=-1) return h;
    if (errno!=EACCES && errno!=EAGAIN) return h; /* permission denied */
    if (i==MAXTRIES) return h;
    dvdelay(WAITSTATE);
  }
}
