#include <sys/types.h>
#include <ctype.h>
#include <string.h>

int strnicmp_ (const char *s1, const char *s2, size_t n)
{
    register int c1, c2, l = 0;

    while (*s1 && *s2 && l < n)
    {
      c1 = tolower (*s1);
      c2 = tolower (*s2);
      if (c1 != c2)
	return (c1 - c2);
      s1++;
      s2++;
      l++;
    }
    if (l < n) return (*s1-*s2);
    return (int) (0);
}

int strncmp_ (const char *s1, const char *s2, size_t n)
{
    register int l = 0;

    while (*s1 && *s2 && l < n)
    {
      if (*s1 != *s2)
	return (*s1 - *s2);
      s1++;
      s2++;
      l++;
    }
    if (l < n) return (*s1-*s2);
    return (int) (0);
}

